// ERPNext - web based ERP (http://erpnext.com)
// Copyright (C) 2012 Web Notes Technologies Pvt Ltd
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


// Onload
// -----------------------------------------
cur_frm.cscript.onload = function(doc, cdt, cdn) {
}

// Refresh
// -----------------------------------------
cur_frm.cscript.refresh = function(doc, cdt, cdn) {
	// read-only for root accounts
  	root_acc = ['Application of Funds (Assets)','Expenses','Income','Source of Funds (Liabilities)'];
	if(inList(root_acc, doc.account_name))
		cur_frm.perm = [[1,0,0], [1,0,0]];

	// hide fields if group
	cur_frm.toggle_fields(['account_type', 'master_type', 'master_name', 'freeze_account', 
		'credit_days', 'credit_limit'], doc.group_or_ledger=='Ledger')	

	// credit days and type if customer or supplier
	cur_frm.toggle_fields(['credit_days', 'credit_limit'], 
		in_list(['Customer', 'Supplier'], doc.master_type))

	// hide tax_rate
	cur_frm.cscript.account_type(doc, cdt, cdn);

	// show / hide convert buttons
	cur_frm.cscript.hide_unhide_group_ledger(doc);
	
	// back to chart of accounts
	cur_frm.add_custom_button('Back To Chart of Accounts', function() {
		wn.set_route('Accounts Browser', 'Account');
	}, 'icon-arrow-left')
	
}

// Fetch parent details
// -----------------------------------------
cur_frm.add_fetch('parent_account', 'debit_or_credit', 'debit_or_credit');
cur_frm.add_fetch('parent_account', 'is_pl_account', 'is_pl_account');

// Hide tax rate based on account type
// -----------------------------------------
cur_frm.cscript.account_type = function(doc, cdt, cdn) {
	cur_frm.toggle_fields(['tax_rate'], doc.account_type == 'Tax')
	cur_frm.toggle_fields(['master_type', 'master_name'], cstr(doc.account_type)=='')
}

// Hide/unhide group or ledger
// -----------------------------------------
cur_frm.cscript.hide_unhide_group_ledger = function(doc) {
	if (cstr(doc.group_or_ledger) == 'Group') {
		cur_frm.add_custom_button('Convert to Ledger', 
			function() { cur_frm.cscript.convert_to_ledger(); }, 'icon-retweet')
	} else if (cstr(doc.group_or_ledger) == 'Ledger') {
		cur_frm.add_custom_button('Convert to Group', 
			function() { cur_frm.cscript.convert_to_group(); }, 'icon-retweet')
	}
}
// Convert group to ledger
// -----------------------------------------
cur_frm.cscript.convert_to_ledger = function(doc, cdt, cdn) {
  $c_obj(cur_frm.get_doclist(),'convert_group_to_ledger','',function(r,rt) {
    if(r.message == 1) {
      refresh_field('group_or_ledger');
      cur_frm.cscript.hide_unhide_group_ledger(cur_frm.get_doc());
    }
  });
}

// Convert ledger to group
// -----------------------------------------
cur_frm.cscript.convert_to_group = function(doc, cdt, cdn) {
  $c_obj(cur_frm.get_doclist(),'convert_ledger_to_group','',function(r,rt) {
    if(r.message == 1) {
      doc.group_or_ledger = 'Group';
      refresh_field('group_or_ledger');
      cur_frm.cscript.hide_unhide_group_ledger(cur_frm.get_doc());
    }
  });
}

// Master name get query
// -----------------------------------------
cur_frm.fields_dict['master_name'].get_query=function(doc){
 if (doc.master_type){
    return 'SELECT `tab'+doc.master_type+'`.name FROM `tab'+doc.master_type+'` WHERE `tab'+doc.master_type+'`.name LIKE "%s" and `tab'+doc.master_type+'`.docstatus != 2 ORDER BY `tab'+doc.master_type+'`.name LIMIT 50';
  }
}

// parent account get query
// -----------------------------------------
cur_frm.fields_dict['parent_account'].get_query = function(doc){
  return 'SELECT DISTINCT `tabAccount`.name FROM `tabAccount` WHERE \
	`tabAccount`.group_or_ledger="Group" AND `tabAccount`.docstatus != 2 AND \
	`tabAccount`.company="'+ doc.company+'" AND `tabAccount`.company is not NULL AND \
	`tabAccount`.name LIKE "%s" ORDER BY `tabAccount`.name LIMIT 50';
}
